addHook("PreThinkFrame", function()
	for player in players.iterate()
        -- Validitycheck
        if not (
			A_CheckExistence(player)
			and player.playerstate == PST_LIVE
			and player.mo.skin == "sonic"
		)
            continue
        end
		
		if player.charability != CA_NONE
			if (player.powers[pw_super] and not player.kr_superpowers)
				player.charability = CA_THOK
			else
				player.charability = CA_DOUBLEJUMP
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	-- Validity check
	if not (
		A_CheckExistence(player)
		and player.playerstate == PST_LIVE
		and player.mo.skin == "sonic"
	)
		return
	end
	
	local mo = player.mo
	
	-- Release drop dash if you hit the ground while charged
	if mo.eflags & MFE_JUSTHITFLOOR
	and mo.dropcharge > 0
	and not (mo.eflags & MFE_SPRUNG)
	and not (mo.state == S_PLAY_SPINDASH)
		A_ReleaseDropDash(player)
		
	-- Otherwise check conditions for charging dropdash
	-- Have to be off the ground to charge
	elseif not (P_IsObjectOnGround(player.mo))
	-- Have to be in a jumping state to charge
	and (player.pflags & PF_JUMPED)
	-- Have to have control to charge
	and not A_CheckNoControl(player) and player.cmd.buttons & BT_USE
	-- Dropdash has to start with a button press, not a hold
	and (not (player.prevbuttons & BT_USE) or mo.dropcharge > 0)
	-- Can't dropdash if Super Sonic's ability changes are turned off
	and not (player.powers[pw_super] and not player.kr_superpowers)
		A_ChargeDropDash(player)
	
	-- If charge conditions aren't met, discharge the dropdash
	else
		if mo.dropcharge > 0
			mo.dropcharge = 0
		end
		if mo.state == S_DROPDASH1
			mo.state = S_PLAY_JUMP
		end
	end
end)

addHook("AbilitySpecial", A_SonicDoubleJump)
